<?php if (!defined('PmWiki')) exit();
/**
 * functions.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2005-2023
 * @note This file is part of Cookbook recipe "Jscm" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package jscm
 */

// **********************************************************
// Some fuctions
// **********************************************************


// *******************************************************
function jscm_set_cm_file($cmpagename) {
    global $Jscm;
    //$cmfileFmt = "uploads/Content/$cmpagename".".txt";
    $cmfileFmt = $Jscm['default']['MenuFilePath']."$cmpagename.js";
    if (file_exists($cmfileFmt)) {
        $cmfileUrl = dirname($_SERVER['SCRIPT_NAME'])."/$cmfileFmt";
        $cmsourcefmt = "<script type='text/javascript' src='$cmfileUrl'></script>";
    }
    return $cmsourcefmt;
}
function jscm_set_cm_source($cmpagename,$action) {
    $cmsourcefmt = '';
    if (PageExists($cmpagename)) {
        $cmpagenameUrl = FmtPageName('$PageUrl', $cmpagename);
        $cmpagenameUrlFmt = $cmpagenameUrl.$action;
        $cmsourcefmt = "<script type='text/javascript' src='$cmpagenameUrlFmt'></script>";
    }
    return $cmsourcefmt;
}

function jscm_get_cmfile_url_fmt($cmfilename) {
}
function jscm_get_cmpage_url_fmt($cmpagename) {
}

function jscm_get_page_content($cmpagename) {
    if (PageExists($cmpagename)) {
        $page = RetrieveAuthPage($cmpagename,'read');
        $cmpagefmt = @$page['text'] . "\n";
        return $cmpagefmt;
    }
    return;
}

// *******************************************************

function jscm_get_theme_fmt($cmTheme,$cmThemeDir,$cmThemeBase,$cmScriptDUrl) {
    $cmThemeBase = substr_replace($cmThemeBase, 'my', 0, 2); #helps in not modifying the default themes js file.
    $cmThemeFmt = "
    <!-- $cmTheme -->
    <script type='text/javascript'><!--
    var $cmThemeBase = '$cmScriptDUrl/themes/$cmThemeDir/';
    // --></script>
    <link rel='stylesheet' type='text/css' href='$cmScriptDUrl/themes/$cmThemeDir/theme.css' />
    <script type='text/javascript' src='$cmScriptDUrl/themes/$cmThemeDir/theme.js'></script>
    <!-- /$cmTheme -->\n";

    return $cmThemeFmt;
}

function jscm_set_draw_fmt($cmDrawMap, $count) {
    global $Jscm, $EnableJscmDebug;

    foreach ($cmDrawMap as $k => $v) { $$k = $v; }

    $prop = ''; $e = ''; $c = ''; $d = '';
    if($clickopen) { $c = $cmTheme . '.clickOpen = 2;'; }
    if($delay > 0) { $d = $cmTheme . '.delay = ' . $delay . ';'; }
    if(isset($effectstr)) {
        if ($effectall) {
            $e =  $cmTheme . '.effect = ' . $effectstr;
        } else {
            $prop = 'var prop = cmClone (' . $cmTheme . ');';
            $e = 'prop.effect = ' . $effectstr;
            $cmTheme = 'prop';
        }
    }

    if($format == 'pmwiki') { $format = "emptyspan('$cmID');"; }

    if ($count == '4') {
        $cmContainerFmt = "\n<div id='$cmID'></div>";
        $cmDrawValues = "cmDraw ('$cmID', $cmMenu, '$cmOrient', $cmTheme);";
    }
    else if ($count == '3') {
        $cmDrawValues = "cmDrawFromText ('$cmID', '$cmOrient', $cmTheme);";
    }
    else if ($count == '0') { #set defaults
        $cmContainerFmt = "\n<div id='$cmID'></div>";
        $cmDrawValues = "cmDraw ('$cmID', $cmMenu, '$cmOrient', $cmTheme);";
    }
    else {
        $cmDrawValues = "";
    }
    if($EnableJscmDebug > 0) {
        $Jscm['debug']['msg']['cmDrawValues'][] = $cmDrawValues;
    }

    $cmDrawFmt = "\n<script type='text/javascript'><!--
    $format $d $c $prop $e $cmDrawValues
    // --></script>";
    $cmDrawHtmlFmt = @$cmContainerFmt . $cmDrawFmt;

    if($cmDrawValues != "") return $cmDrawHtmlFmt;
}

// *******************************************************


## JsCookMenu lib/js files
// *******************************************************
function jscm_set_lib() {
    global $Jscm, $HTMLHeaderFmt;
    //$jscmInstallUrl = &$Jscm['Install']['dirUrl'];
    $jscmInstallUrlPath = &$Jscm['Install']['dirUrlPath'];

$HTMLHeaderFmt['jscmLib'] = "
<!--jscmLibFmt-->
<script type='text/javascript' src='$jscmInstallUrlPath/js/JSCookMenu.js'></script>
<script type='text/javascript' src='$jscmInstallUrlPath/js/effect.js'></script>
<script type='text/javascript'><!--
  function emptyspan(id) {
    a = document.getElementById(id); if( !a ) return;
    ts = a.getElementsByTagName('li');
      for (var i = 0; i < ts.length; i++) { var elm = document.createElement('span');
      var t = ts[i]; if(t.children[0] && t.children[0].tagName == 'A') t.insertBefore(elm, t.children[0]); }
  }
--></script>
<!--/jscmLibFmt-->";
//$HTMLHeaderFmt['cmSource'] = "\n".implode("\n", $cmSources);
}

## Initiate jscookmenu lib
function jscm_init_lib() {
    static $init_count;
    if($init_count < 1) {
        global $Jscm;
        jscm_set_lib();
        $Jscm['theme']['style'] = array();
        include_once($Jscm['Current']['dir'].'/themes/themes.php');
    }
    $init_count++;
    return;
}
// *******************************************************

// *******************************************************

/**
 * Set/Show debug.
 * @param int value for debug level
 */
// *******************************************************
function JscmDebug($EnableJscmDebug=0) {
    global $Jscm;
    if(1 === $EnableJscmDebug) {
        $jscmDebugMsg = print_r($Jscm['debug']['msg'], true);
    }
    if(2 === $EnableJscmDebug) {
        $jscmDebugMsg = print_r($Jscm, true);
    }
    return @$jscmDebugMsg;
}
// *******************************************************

