<?php if (!defined('PmWiki')) exit();
/**
 * set_args_map.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2005-2023
 * @note This file is part of Cookbook recipe "Jscm" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package jscm
 */


/*
   Set default values
*/
$menu_opts = array('id', 'name', 'orient', 'theme', 'themedir', 'themebase');
$defauts = array('cmMainID', 'cmMainMenu', 'hbr', 'cmThemeNB', 
                 'ThemeNB', @$Jscm['default']['menu']['theme'].'Base');
foreach($defauts as $k=>$v) { SDV($Jscm['default']['menu'][$menu_opts[$k]], $v); }

global $cmDrawParam, $cmDrawFromTextParam,
       $cmDrawDefault, $cmOrients, $cmThemes;

/* 
   see jscookmenu.js
   cmDraw (cmID, cmMenu, cmOrient, nodeProperties, prefix);
   cmDrawFromText ('cmID', 'cmOrient', cmTheme, 'cmThemeDir');
*/

$cmDrawParam = array('cmID', 'cmMenu', 'cmOrient', 'cmTheme', 'cmThemeDir', 'cmThemeBase');
//$cmDrawParam = array('cmID', 'cmMenu', 'cmOrient', 'cmTheme');
foreach($cmDrawParam as $k=>$v) { $$v = $Jscm['default']['menu'][$menu_opts[$k]]; }

$cmDrawFromTextParam = array('cmID', 'cmOrient', 'cmTheme', 'cmThemeDir', 'cmThemeBase');
//$cmDrawFromTextParam = array('cmID', 'cmOrient', 'cmTheme');

$cmDrawDefault = compact($cmDrawParam);
SDVA($cmOrients, array('hbr', 'hbl', 'hur', 'hul', 'vbr', 'vbl', 'vur', 'vul'));
SDVA($cmThemes, array(
    'cmThemeMiniBlack' => 'ThemeMiniBlack',
    'cmThemePanel' => 'ThemePanel',
    'cmThemeIE' => 'ThemeIE',
    'cmThemeOffice' => 'ThemeOffice',
    'cmThemeOffice2003' => 'ThemeOffice2003',
    'cmThemeNB' => 'ThemeNB',
    'cmThemeMini' => 'ThemeMini',
    'cmThemeInfoClick' => 'ThemeInfoClick',
    'cmThemeGray' => 'ThemeGray',
));
// *******************************************************

function jscm_get_drawmap($params) {
    global $Jscm,
           $cmDrawParam, $cmDrawFromTextParam,
           $cmDrawDefault, $cmOrients, $cmThemes,
           $EnableJscmDebug;
    $args = ParseArgs($params);
    $count = count($args[""]);
    if($EnableJscmDebug > 0) { //debug
        //$Jscm['debug']['msg']['parseArgs'][] = $args;
    }
    $cmDrawValue = array();

    if ($count == '4') { //number of items in params
        foreach ($args[""] as $k => $v) { $cmDrawValue[$cmDrawParam[$k]] = $v; }
        foreach ($cmDrawValue as $k => $v) { $$k = $v; }
    }
    if ($count == '3') { //number of items in params
        foreach ($args[""] as $k => $v) { $cmDrawValue[$cmDrawFromTextParam[$k]] = $v; }
        foreach ($cmDrawValue as $k => $v) { $$k = $v; }
    }
    if($EnableJscmDebug > 0) { //debug
        $Jscm['debug']['msg']['cmDrawValue'][] = $cmDrawValue;
    }

    if (!preg_match('/^[a-zA-Z0-9]+$/', $cmID)) {
       $cmID = $cmDrawDefault['cmID'];
    }
    if (isset($cmMenu) && !preg_match('/^[a-zA-Z0-9]+$/', $cmMenu)) {
         $cmMenu = $cmDrawDefault['cmMenu'];
    }
    $cmOrient = (in_array($cmDrawValue['cmOrient'], $cmOrients)) ?
             $cmDrawValue['cmOrient'] : $cmDrawDefault['cmOrient'];
    foreach ($cmThemes as $k => $v) {
        if ($cmDrawValue['cmTheme'] == $k) {
            $cmTheme = $k; $cmThemeDir = $v; break;
        } else {
            $cmTheme = $cmDrawDefault['cmTheme'];
            $cmThemeDir = $cmDrawDefault['cmThemeDir'];
        }
    }
    $cmThemeBase = $cmTheme.'Base';

    $cmDrawMap = @compact($cmDrawParam);

    $effect = isset($args['effect']) ? $args['effect'] : '';
    preg_match ('/(fading|sliding):{0,1}([0-9]{0,2}):{0,1}([0-9]{0,2}):{0,1}(\w*)/', $effect, $m);

    if(count($m) > 0) {
      $cmDrawMap['effect'] = $m[1];
      if ( 'fading' === $m[1] ) {
          $e2 = ( $m[2] ) ? $m[2] : 30; $e3 = ( $m[3] ) ? $m[3] : 80;
          $cmDrawMap['effectstr'] = 'new CMFadingEffect (' . $e2 . ', ' . $e3 . ');';
          $cmDrawMap['effectall'] = ( 'all' === $m[4] ) ? 1 : 0;
      }
      if ( 'sliding' === $m[1] ) {
          $e2 = ( $m[2] ) ? $m[2] : 8;
          $cmDrawMap['effectstr'] = 'new CMSlidingEffect (' . $e2 . ');';
          $cmDrawMap['effectall'] = ( 'all' === $m[4] ) ? 1 : 0;
      }
    }
    //print_r(count($m)); exit;

    $cmDrawMap['clickopen'] = (@$args['clickopen'] === '1') ? 1 : 0;
    $delay = preg_replace('/[^0-9]/', '', @$args['delay']);
    $cmDrawMap['delay'] = ($delay) ? $delay : 0;

    $cmDrawMap['format'] = (@$args['format'] === 'pmwiki') ? 'pmwiki' : '';

    return $cmDrawMap;

}

//echo '<pre>'; print_r($params); echo '</pre>'; exit;

